/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package coinserver.blackjack;

/**
 *
 * @author Yury V. Reshetov
 */

class Card {
    public static final int SPADES = 0; // Codes for the 4 suits.
    // Codes for the 4 suits.
    public static final int HEARTS = 1;
    // Codes for the 4 suits.
    public static final int DIAMONDS = 2;
    // Codes for the 4 suits.
    public static final int CLUBS = 3;
    public static final int ACE = 1; // Codes for the non-numeric cards.
    // Codes for the non-numeric cards.
    public static final int JACK = 11; //   Cards 2 through 10 have their
    // Codes for the non-numeric cards.
    //   Cards 2 through 10 have their
    public static final int QUEEN = 12; //   numerical values for their codes.
    // Codes for the non-numeric cards.
    //   Cards 2 through 10 have their
    //   numerical values for their codes.
    public static final int KING = 13;
    private final int suit; // The suit of this card, one of the constants
    //    SPADES, HEARTS, DIAMONDS, CLUBS.
    private final int value; // The value of this card, from 1 to 11.
    BlackjackConsole card;

    // The value of this card, from 1 to 11.
    public Card(int theValue, int theSuit, BlackjackConsole card) {
        this.card = card;
        // Construct a card with the specified value and suit.
        // Value must be between 1 and 13.  Suit must be between
        // 0 and 3.  If the parameters are outside these ranges,
        // the constructed card object will be invalid.
        // Construct a card with the specified value and suit.
        // Value must be between 1 and 13.  Suit must be between
        // 0 and 3.  If the parameters are outside these ranges,
        // the constructed card object will be invalid.
        value = theValue;
        suit = theSuit;
    }

    public int getSuit() {
        // Return the int that codes for this card's suit.
        return suit;
    }

    public int getValue() {
        // Return the int that codes for this card's value.
        return value;
    }

    public String getSuitAsString() {
        // Return a String representing the card's suit.
        // (If the card's suit is invalid, "??" is returned.)
        switch (suit) {
            case SPADES:
                return "Spades";
            case HEARTS:
                return "Hearts";
            case DIAMONDS:
                return "Diamonds";
            case CLUBS:
                return "Clubs";
            default:
                return "??";
        }
    }

    public String getValueAsString() {
        // Return a String representing the card's value.
        // If the card's value is invalid, "??" is returned.
        switch (value) {
            case 1:
                return "Ace";
            case 2:
                return "2";
            case 3:
                return "3";
            case 4:
                return "4";
            case 5:
                return "5";
            case 6:
                return "6";
            case 7:
                return "7";
            case 8:
                return "8";
            case 9:
                return "9";
            case 10:
                return "10";
            case 11:
                return "Jack";
            case 12:
                return "Queen";
            case 13:
                return "King";
            default:
                return "??";
        }
    }

    public String toString() {
        // Return a String representation of this card, such as
        // "10 of Hearts" or "Queen of Spades".
        return getValueAsString() + " of " + getSuitAsString();
    }
    
}
