/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package menu;

import java.util.*;

/**
 *
 * @author Yury V. Reshetov
 */
public class Menu {
    
    protected ArrayList al = new ArrayList();
    protected ArrayList errors = new ArrayList();
    private boolean[] points = new boolean[100];
    
    public Menu() {
        al.add("");
        al.add("Menu:");
        al.add("");
        Arrays.fill(points, false);
        this.setPoint(0);
    }
    
    public void addPoint(String name) {
        al.add(name);
    }
    
    public void setPoint(int point) {
        this.points[point] = true;;
    }
    
    public boolean checkPoint(int point) {
        return this.points[point];        
    }
    
    @Override
    public String toString() {
        String result = "";
        Iterator it = this.errors.iterator();
        while (it.hasNext()) {
            result = result + (String)it.next() + "\r\n";
        }
        it = this.al.iterator();
        while (it.hasNext()) {
            result = result + (String)it.next() + "\r\n";
        }
        result = result + "0. Exit\r\n";
        result = result + "Enter item: ";
        return result;
    }
    
    public boolean checkCommand(String command) {
        this.errors = new ArrayList();
        if (command.trim().length() != 1) {
            this.errors.add(0, "Incorrect item: " + command.trim());
            this.errors.add(0, "");
            return false;
        }
        int number = this.getNumber(command.trim());
        if (number < 0) {
            this.errors.add(0, "Incorrect item: " + command.trim());
            this.errors.add(0, "");
            return false;
        }
        boolean result = this.checkPoint(number);
        if (! result) {
            this.errors.add(0, "Incorrect item: " + command.trim());
            this.errors.add(0, "");
        }
        return result;
    }
    
      private int getNumber(String number) {
      int result = 0;
      try {
          result = Integer.parseInt(number);
      } catch (Exception ex) {
          result = -1;
      }
      return result;
  }

    
}
