/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Manager.java
 *
 * Created on 30.10.2013, 14:56:09
 */
package walletsmanager;

import java.awt.*;
import java.math.*;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 *
 * @author User
 */
public class Manager extends java.awt.Frame implements Runnable {
    
    private BigInteger prime =       new BigInteger("101558939302851404456426761704353705658322742695488329836901999984373457836751");
    private BigInteger commonnumber = new BigInteger("72535531302939977163895671131946125079448816009282099533868737070972879400192");
    private BigInteger secret = null;
    private BigInteger publickey = null;
    private int answer = -1;
    private String amount = "";
    private String walletname = "";
    private String proxyhost = "localhost";
    private int proxyport = 9150; //Tor proxy port
    private String host = "2r7wpxntx3uv2gwm.onion";
    private int port = 23;

    /** Creates new form Manager */
    public Manager() {
        initComponents();
        Thread th = new Thread(this);
        th.start();
    }
    
    
    private BigInteger createWallet() {
        int bits = 256;
        java.security.SecureRandom rand = new java.security.SecureRandom();
        BigInteger secret1 = new BigInteger(bits, rand);
        while (secret1.mod(prime).bitLength() != bits) {
            secret1 = new BigInteger(bits, rand);
        }
        secret1 = secret1.mod(prime);
        BigInteger publickey1 = commonnumber.modPow(secret1, prime);
        try {
            FileDialog fd = new FileDialog(this, "Save new wallet", FileDialog.SAVE);
            fd.setFile("*.wlt");
            fd.setVisible(true);
            if (fd.getDirectory() != null) {
                String filename = fd.getFile();
                if (! filename.endsWith(".wlt")) {
                    filename = filename + ".wlt";
                }
                File f = new File(fd.getDirectory() + filename);
                PrintWriter pw = new PrintWriter(new FileWriter(f));
                pw.println("1");
                pw.println(publickey1.toString(16));
                pw.println(secret1.toString(16));
                pw.flush();
                pw.close();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return publickey1;
    }
    
    @Override
    public void run() {
        try {
            Socket socket = null;
            if (this.proxyhost.equals("")) {
                socket = new Socket(this.host, this.port);
            } else {
                InetSocketAddress address = new InetSocketAddress(this.proxyhost, this.proxyport);
                Proxy proxy = new Proxy(Proxy.Type.SOCKS, address);
                socket = new Socket(proxy);
                InetSocketAddress inet = new InetSocketAddress(this.host, this.port);
                socket.connect(inet);
            }
            BufferedReader br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            PrintWriter pw = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
            String s = "";
            while ((s = br.readLine().trim()) != null) {
                ta.append(s + "\n");
                if (s.equals("Menu:")) {
                    CardLayout cl = (CardLayout)this.panel8.getLayout();
                    cl.show(panel8, "card1");
                    s = br.readLine().trim();
                    s = br.readLine().trim();
                    while (! s.startsWith("Enter item:")) {
                        ta.append(s + "\n");
                        StringTokenizer st = new StringTokenizer(s, ".");
                        String sn = st.nextToken();
                        String label = st.nextToken();
                        while (st.hasMoreTokens()) {
                            label = label + "." + st.nextToken();
                        }
                        int num = Integer.parseInt(sn);
                        switch (num) {
                            case 1: 
                                this.b1.setVisible(true); this.b1.setLabel(label); break;
                            case 2: 
                                this.b2.setVisible(true); this.b2.setLabel(label); break;
                            case 3: 
                                this.b3.setVisible(true); this.b3.setLabel(label); break;
                            case 4: 
                                this.b4.setVisible(true); this.b4.setLabel(label); break;
                            case 5: 
                                this.b5.setVisible(true); this.b5.setLabel(label); break;
                            case 6: 
                                this.b6.setVisible(true); this.b6.setLabel(label); break;
                            default: 
                                this.b0.setVisible(true); this.b0.requestFocus(); this.b0.setLabel(label);
                        }
                        s = br.readLine().trim();
                    }
                    ta.append(s + " ");
                    while(this.answer < 0) {
                        Thread.sleep(500);
                    }
                    this.b0.setVisible(false);
                    this.b1.setVisible(false);
                    this.b2.setVisible(false);
                    this.b3.setVisible(false);
                    this.b4.setVisible(false);
                    this.b5.setVisible(false);
                    this.b6.setVisible(false);
                    this.b0.setLabel("");
                    this.b1.setLabel("");
                    this.b2.setLabel("");
                    this.b3.setLabel("");
                    this.b4.setLabel("");
                    this.b5.setLabel("");
                    this.b6.setLabel("");
                    ta.append(answer + "\n");
                    pw.println(answer);
                    pw.flush();
                    answer = -1;
                }
                if (s.startsWith("Enter the number of wallet:")) {
                    if (this.publickey == null) {
                        FileDialog fd = new FileDialog(this, "Open wallet", FileDialog.LOAD);
                        fd.setFile("*.wlt");
                        fd.setVisible(true);
                        if (fd.getDirectory() != null) {
                           this.walletname = fd.getDirectory() + fd.getFile();
                           File f = new File(this.walletname);
                           BufferedReader brf = new BufferedReader(new FileReader(f));
                           brf.readLine();
                           String pk = brf.readLine().trim();
                           String sk = brf.readLine().trim();
                           brf.close();
                           this.publickey = new BigInteger(pk, 16);
                           this.secret = new BigInteger(sk, 16);
                        }
                    }
                    if (this.publickey != null) {
                        pw.println(this.publickey.toString(16));
                        pw.flush();
                        ta.append(this.publickey.toString(16) + "\n");
                    }
                }
                if (s.startsWith("Control number:")) {
                    StringTokenizer st = new StringTokenizer(s, ":");
                    st.nextToken();
                    String control = st.nextToken();
                    BigInteger pin = new BigInteger(control.trim(), 16).modPow(secret, prime);
                    s = br.readLine();
                    ta.append(s + "\n");
                    pw.println(pin.toString(16));
                    pw.flush();
                    ta.append("PIN code: " + pin.toString(16) + "\n");
                }
                if (s.startsWith("Amount:")) {
                    CardLayout cl = (CardLayout)this.panel8.getLayout();
                    cl.show(panel8, "card2");
                    this.amount = "";
                    this.textField1.setEnabled(true);
                    this.textField1.requestFocus();
                    label1.setEnabled(true);
                    label2.setEnabled(true);
                    this.button1.setEnabled(true);
                    while (this.amount.trim().equals("")) {
                        Thread.sleep(500);
                    }
                    this.textField1.setEnabled(false);
                    label1.setEnabled(false);
                    label2.setEnabled(false);
                    this.button1.setEnabled(false);
                    pw.println(this.amount);
                    pw.flush();
                }
                if (s.startsWith("Enter the number of new wallet:")) {
                    String newwalletnumber = this.createWallet().toString(16);
                    pw.println(newwalletnumber);
                    pw.flush();
                }
                if (s.startsWith("Enter number wallet for receiving coins:")) {
                    BigInteger walletnumber = BigInteger.ONE;
                    FileDialog fd = new FileDialog(this, "Open wallet for receiving coins", FileDialog.LOAD);
                    fd.setFile("*.wlt");
                    fd.setVisible(true);
                    if (fd.getDirectory() != null) {
                        File f = new File(fd.getDirectory() + fd.getFile());
                        BufferedReader bfr = new BufferedReader(new FileReader(f));
                        bfr.readLine();
                        walletnumber = new BigInteger(bfr.readLine().trim(), 16);
                        bfr.close();
                    }
                    pw.println(walletnumber.toString(16));
                    pw.flush();
                    ta.append("Number: " + walletnumber.toString(16) + "\n");
                    File f = new File(this.walletname);
                    f.delete();
                }
            }
            socket.close();
        } catch (Exception ex) {
        }
    }
        

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panel2 = new java.awt.Panel();
        panel3 = new java.awt.Panel();
        ta = new java.awt.TextArea();
        panel4 = new java.awt.Panel();
        panel7 = new java.awt.Panel();
        panel8 = new java.awt.Panel();
        panel1 = new java.awt.Panel();
        b1 = new java.awt.Button();
        b2 = new java.awt.Button();
        b3 = new java.awt.Button();
        b4 = new java.awt.Button();
        b5 = new java.awt.Button();
        b6 = new java.awt.Button();
        b0 = new java.awt.Button();
        panel6 = new java.awt.Panel();
        label1 = new java.awt.Label();
        textField1 = new java.awt.TextField();
        label2 = new java.awt.Label();
        button1 = new java.awt.Button();
        panel9 = new java.awt.Panel();
        panel10 = new java.awt.Panel();
        panel11 = new java.awt.Panel();
        panel5 = new java.awt.Panel();
        menuBar1 = new java.awt.MenuBar();
        menu1 = new java.awt.Menu();
        menuItem2 = new java.awt.MenuItem();
        menuItem1 = new java.awt.MenuItem();

        setTitle("Color coins. Wallet Manager");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        add(panel2, java.awt.BorderLayout.WEST);
        add(panel3, java.awt.BorderLayout.EAST);
        add(ta, java.awt.BorderLayout.CENTER);

        panel4.setLayout(new java.awt.BorderLayout());
        panel4.add(panel7, java.awt.BorderLayout.NORTH);

        panel8.setLayout(new java.awt.CardLayout());

        panel1.setLayout(new java.awt.GridLayout(7, 1));

        b1.setLabel(" ");
        b1.setVisible(false);
        b1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b1ActionPerformed(evt);
            }
        });
        panel1.add(b1);

        b2.setLabel(" ");
        b2.setVisible(false);
        b2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b2ActionPerformed(evt);
            }
        });
        panel1.add(b2);

        b3.setLabel(" ");
        b3.setVisible(false);
        b3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b3ActionPerformed(evt);
            }
        });
        panel1.add(b3);

        b4.setLabel(" ");
        b4.setVisible(false);
        b4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b4ActionPerformed(evt);
            }
        });
        panel1.add(b4);

        b5.setLabel(" ");
        b5.setVisible(false);
        b5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b5ActionPerformed(evt);
            }
        });
        panel1.add(b5);

        b6.setLabel(" ");
        b6.setVisible(false);
        b6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b6ActionPerformed(evt);
            }
        });
        panel1.add(b6);

        b0.setLabel(" ");
        b0.setVisible(false);
        b0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b0ActionPerformed(evt);
            }
        });
        panel1.add(b0);

        panel8.add(panel1, "card1");

        label1.setEnabled(false);
        label1.setText("Amount:");
        panel6.add(label1);

        textField1.setEnabled(false);
        textField1.setText("0000.000000");
        textField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                textfocus(evt);
            }
        });
        panel6.add(textField1);

        label2.setEnabled(false);
        label2.setText("coins");
        panel6.add(label2);

        button1.setEnabled(false);
        button1.setLabel("OK");
        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button1ActionPerformed(evt);
            }
        });
        panel6.add(button1);

        panel8.add(panel6, "card2");

        panel4.add(panel8, java.awt.BorderLayout.CENTER);
        panel4.add(panel9, java.awt.BorderLayout.EAST);
        panel4.add(panel10, java.awt.BorderLayout.SOUTH);
        panel4.add(panel11, java.awt.BorderLayout.WEST);

        add(panel4, java.awt.BorderLayout.SOUTH);
        add(panel5, java.awt.BorderLayout.NORTH);

        menu1.setLabel("File");

        menuItem2.setLabel("Copy the check wallet ...");
        menuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItem2ActionPerformed(evt);
            }
        });
        menu1.add(menuItem2);
        menu1.addSeparator();
        menuItem1.setLabel("Exit");
        menuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItem1ActionPerformed(evt);
            }
        });
        menu1.add(menuItem1);

        menuBar1.add(menu1);

        setMenuBar(menuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    private void b1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b1ActionPerformed
        // TODO add your handling code here:
        this.b1.setVisible(false);
        this.answer = 1;
    }//GEN-LAST:event_b1ActionPerformed

    private void b2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b2ActionPerformed
        // TODO add your handling code here:
        this.b2.setVisible(false);
        this.answer = 2;
    }//GEN-LAST:event_b2ActionPerformed

    private void b3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b3ActionPerformed
        // TODO add your handling code here:
        this.b3.setVisible(false);
        this.answer = 3;
    }//GEN-LAST:event_b3ActionPerformed

    private void b4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b4ActionPerformed
        // TODO add your handling code here:
        this.b4.setVisible(false);
        this.answer = 4;
    }//GEN-LAST:event_b4ActionPerformed

    private void b5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b5ActionPerformed
        // TODO add your handling code here:
        this.b5.setVisible(false);
        this.answer = 5;
    }//GEN-LAST:event_b5ActionPerformed

    private void b6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b6ActionPerformed
        // TODO add your handling code here:
        this.b6.setVisible(false);
        this.answer = 6;
    }//GEN-LAST:event_b6ActionPerformed

    private void b0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b0ActionPerformed
        // TODO add your handling code here:
        this.b0.setVisible(false);
        this.answer = 0;
    }//GEN-LAST:event_b0ActionPerformed

    private void textfocus(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_textfocus
        // TODO add your handling code here:
        this.textField1.selectAll();
    }//GEN-LAST:event_textfocus

    private void button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button1ActionPerformed
        // TODO add your handling code here:
        this.amount = this.textField1.getText();                
    }//GEN-LAST:event_button1ActionPerformed

    private void menuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItem1ActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_menuItem1ActionPerformed

    private void menuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItem2ActionPerformed
        // TODO add your handling code here:
        FileDialog fd = new FileDialog(this, "Open the wallet to copy", FileDialog.LOAD);
        fd.setFile(".wlt");
        fd.setVisible(true);
        if (fd.getDirectory() != null) {
            FileDialog fd1 = new FileDialog(this, "Save a copy of the check", FileDialog.SAVE);
            fd1.setFile(".wlt");
            fd1.setVisible(true);
            if (fd.getDirectory() != null) {
                try {
                    BufferedReader br = new BufferedReader(new FileReader(fd.getDirectory() + fd.getFile()));
                    String version = br.readLine();
                    String pubkey = br.readLine();
                    br.close();
                    String filename = fd1.getFile();
                    if (! filename.endsWith(".wlt")) {
                        filename = filename + ".wlt";
                    }
                    PrintWriter pw = new PrintWriter(new FileWriter(fd1.getDirectory() + filename));
                    pw.println(version);
                    pw.println(pubkey);
                    pw.println("0");
                    pw.flush();
                    pw.close();
                } catch (Exception ex) {
                    
                }
            }
        }
    }//GEN-LAST:event_menuItem2ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Button b0;
    private java.awt.Button b1;
    private java.awt.Button b2;
    private java.awt.Button b3;
    private java.awt.Button b4;
    private java.awt.Button b5;
    private java.awt.Button b6;
    private java.awt.Button button1;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Menu menu1;
    private java.awt.MenuBar menuBar1;
    private java.awt.MenuItem menuItem1;
    private java.awt.MenuItem menuItem2;
    private java.awt.Panel panel1;
    private java.awt.Panel panel10;
    private java.awt.Panel panel11;
    private java.awt.Panel panel2;
    private java.awt.Panel panel3;
    private java.awt.Panel panel4;
    private java.awt.Panel panel5;
    private java.awt.Panel panel6;
    private java.awt.Panel panel7;
    private java.awt.Panel panel8;
    private java.awt.Panel panel9;
    private java.awt.TextArea ta;
    private java.awt.TextField textField1;
    // End of variables declaration//GEN-END:variables
}
